postproc: Add mode and refrence frame visualizers.
[libvpx.git] / configure
blob39ef83ffa1327db765fbc02ff826cdbc60089efd
1 #!/bin/bash
2 ##
3 ## configure
4 ##
5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
16 source_path=${0%/*}
17 . "${source_path}/build/make/configure.sh"
19 show_help(){
20 show_help_pre
21 cat << EOF
22 Advanced options:
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_psnr} output of PSNR data, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_runtime_cpu_detect} runtime cpu detection
41 ${toggle_shared} shared library support
42 ${toggle_small} favor smaller size over speed
43 ${toggle_arm_asm_detok} assembly version of the detokenizer (ARM platforms only)
45 Codecs:
46 Codecs can be selectively enabled or disabled individually, or by family:
47 --disable-<codec>
48 is equivalent to:
49 --disable-<codec>-encoder
50 --disable-<codec>-decoder
52 Codecs available in this distribution:
53 EOF
54 #restore editor state '
56 local family;
57 local last_family;
58 local c;
59 local str;
60 for c in ${CODECS}; do
61 family=${c%_*}
62 if [ "${family}" != "${last_family}" ]; then
63 [ -z "${str}" ] || echo "${str}"
64 str="$(printf ' %10s:' ${family})"
66 str="${str} $(printf '%10s' ${c#*_})"
67 last_family=${family}
68 done
69 echo "${str}"
70 show_help_post
74 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
77 # all_platforms is a list of all supported target platforms. Maintain
78 # alphabetically by architecture, generic-gnu last.
79 all_platforms="${all_platforms} armv5te-linux-rvct"
80 all_platforms="${all_platforms} armv5te-linux-gcc"
81 all_platforms="${all_platforms} armv5te-symbian-gcc"
82 all_platforms="${all_platforms} armv5te-wince-vs8"
83 all_platforms="${all_platforms} armv6-darwin-gcc"
84 all_platforms="${all_platforms} armv6-linux-rvct"
85 all_platforms="${all_platforms} armv6-linux-gcc"
86 all_platforms="${all_platforms} armv6-symbian-gcc"
87 all_platforms="${all_platforms} armv6-wince-vs8"
88 all_platforms="${all_platforms} iwmmxt-linux-rvct"
89 all_platforms="${all_platforms} iwmmxt-linux-gcc"
90 all_platforms="${all_platforms} iwmmxt-wince-vs8"
91 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
92 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
93 all_platforms="${all_platforms} iwmmxt2-wince-vs8"
94 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
95 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
96 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
97 all_platforms="${all_platforms} mips32-linux-gcc"
98 all_platforms="${all_platforms} ppc32-darwin8-gcc"
99 all_platforms="${all_platforms} ppc32-darwin9-gcc"
100 all_platforms="${all_platforms} ppc32-linux-gcc"
101 all_platforms="${all_platforms} ppc64-darwin8-gcc"
102 all_platforms="${all_platforms} ppc64-darwin9-gcc"
103 all_platforms="${all_platforms} ppc64-linux-gcc"
104 all_platforms="${all_platforms} sparc-solaris-gcc"
105 all_platforms="${all_platforms} x86-darwin8-gcc"
106 all_platforms="${all_platforms} x86-darwin8-icc"
107 all_platforms="${all_platforms} x86-darwin9-gcc"
108 all_platforms="${all_platforms} x86-darwin9-icc"
109 all_platforms="${all_platforms} x86-linux-gcc"
110 all_platforms="${all_platforms} x86-linux-icc"
111 all_platforms="${all_platforms} x86-solaris-gcc"
112 all_platforms="${all_platforms} x86-win32-gcc"
113 all_platforms="${all_platforms} x86-win32-vs7"
114 all_platforms="${all_platforms} x86-win32-vs8"
115 all_platforms="${all_platforms} x86-win32-vs9"
116 all_platforms="${all_platforms} x86_64-darwin9-gcc"
117 all_platforms="${all_platforms} x86_64-linux-gcc"
118 all_platforms="${all_platforms} x86_64-linux-icc"
119 all_platforms="${all_platforms} x86_64-solaris-gcc"
120 all_platforms="${all_platforms} x86_64-win64-vs8"
121 all_platforms="${all_platforms} x86_64-win64-vs9"
122 all_platforms="${all_platforms} universal-darwin8-gcc"
123 all_platforms="${all_platforms} universal-darwin9-gcc"
124 all_platforms="${all_platforms} generic-gnu"
126 # all_targets is a list of all targets that can be configured
127 # note that these should be in dependency order for now.
128 all_targets="libs examples docs"
130 # all targets available are enabled, by default.
131 for t in ${all_targets}; do
132 [ -f ${source_path}/${t}.mk ] && enable ${t}
133 done
135 # check installed doxygen version
136 doxy_version=$(doxygen --version 2>/dev/null)
137 doxy_major=${doxy_version%%.*}
138 if [ ${doxy_major:-0} -ge 1 ]; then
139 doxy_version=${doxy_version#*.}
140 doxy_minor=${doxy_version%%.*}
141 doxy_patch=${doxy_version##*.}
143 [ $doxy_major -gt 1 ] && enable doxygen
144 [ $doxy_minor -gt 5 ] && enable doxygen
145 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
148 # install everything except the sources, by default. sources will have
149 # to be enabled when doing dist builds, since that's no longer a common
150 # case.
151 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
152 enable install_bins
153 enable install_libs
155 enable optimizations
156 enable fast_unaligned #allow unaligned accesses, if supported by hw
157 enable md5
158 enable spatial_resampling
159 enable multithread
161 [ -d ${source_path}/../include ] && enable alt_tree_layout
162 for d in vp8; do
163 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
164 done
166 if ! enabled alt_tree_layout; then
167 # development environment
168 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
169 else
170 # customer environment
171 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
172 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
174 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
177 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
178 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
180 ARCH_LIST="
182 mips
184 x86_64
185 ppc32
186 ppc64
188 ARCH_EXT_LIST="
189 armv5te
190 armv6
191 armv7
192 iwmmxt
193 iwmmxt2
195 mips32
199 sse2
200 sse3
201 ssse3
203 altivec
205 HAVE_LIST="
206 ${ARCH_EXT_LIST}
207 vpx_ports
208 stdint_h
209 alt_tree_layout
210 pthread_h
211 sys_mman_h
213 CONFIG_LIST="
214 external_build
215 install_docs
216 install_bins
217 install_libs
218 install_srcs
219 debug
220 gprof
221 gcov
222 rvct
224 msvs
226 big_endian
228 codec_srcs
229 debug_libs
230 fast_unaligned
231 mem_manager
232 mem_tracker
233 mem_checks
236 dequant_tokens
237 dc_recon
238 runtime_cpu_detect
239 postproc
240 multithread
241 psnr
242 ${CODECS}
243 ${CODEC_FAMILIES}
244 encoders
245 decoders
246 static_msvcrt
247 spatial_resampling
248 realtime_only
249 shared
250 small
251 arm_asm_detok
253 CMDLINE_SELECT="
254 extra_warnings
255 werror
256 install_docs
257 install_bins
258 install_libs
259 install_srcs
260 debug
261 gprof
262 gcov
264 optimizations
265 ccache
266 runtime_cpu_detect
268 libs
269 examples
270 libc
272 fast_unaligned
273 codec_srcs
274 debug_libs
277 dequant_tokens
278 dc_recon
279 postproc
280 multithread
281 psnr
282 ${CODECS}
283 ${CODEC_FAMILIES}
284 static_msvcrt
285 mem_tracker
286 spatial_resampling
287 realtime_only
288 shared
289 small
290 arm_asm_detok
293 process_cmdline() {
294 for opt do
295 optval="${opt#*=}"
296 case "$opt" in
297 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
298 *) process_common_cmdline $opt
300 esac
301 done
304 post_process_cmdline() {
305 local c
307 # If the codec family is disabled, disable all components of that family.
308 # If the codec family is enabled, enable all components of that family.
309 log_echo "Configuring selected codecs"
310 for c in ${CODECS}; do
311 disabled ${c%%_*} && disable ${c}
312 enabled ${c%%_*} && enable ${c}
313 done
315 # Enable all detected codecs, if they haven't been disabled
316 for c in ${CODECS}; do soft_enable $c; done
318 # Enable the codec family if any component of that family is enabled
319 for c in ${CODECS}; do
320 enabled $c && enable ${c%_*}
321 done
323 # Set the {en,de}coders variable if any algorithm in that class is enabled
324 for c in ${CODECS}; do
325 enabled ${c} && enable ${c##*_}s
326 done
332 process_targets() {
333 enabled child || write_common_config_banner
334 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
336 # TODO: add host tools target (obj_int_extract, etc)
338 # For fat binaries, call configure recursively to configure for each
339 # binary architecture to be included.
340 if enabled universal; then
341 # Call configure (ourselves) for each subarchitecture
342 for arch in $fat_bin_archs; do
343 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
344 done
347 # The write_common_config (config.mk) logic is deferred until after the
348 # recursive calls to configure complete, becuase we want our universal
349 # targets to be executed last.
350 write_common_config_targets
351 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
353 # Calculate the default distribution name, based on the enabled features
354 local cf
355 local DIST_DIR=vpx
356 for cf in $CODEC_FAMILIES; do
357 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
358 DIST_DIR="${DIST_DIR}-${cf}"
359 elif enabled ${cf}_encoder; then
360 DIST_DIR="${DIST_DIR}-${cf}cx"
361 elif enabled ${cf}_decoder; then
362 DIST_DIR="${DIST_DIR}-${cf}dx"
364 done
365 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
366 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
367 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
368 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
369 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
370 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
371 case "${tgt_os}" in
372 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
373 DIST_DIR="${DIST_DIR}-${tgt_cc}"
375 esac
376 if [ -f "${source_path}/build/make/version.sh" ]; then
377 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
378 DIST_DIR="${DIST_DIR}-${ver}"
379 ver=${ver%%-*}
380 VERSION_PATCH=${ver##*.}
381 ver=${ver%.*}
382 VERSION_MINOR=${ver##*.}
383 ver=${ver#v}
384 VERSION_MAJOR=${ver%.*}
386 enabled child || cat <<EOF >> config.mk
387 ifeq (\$(MAKECMDGOALS),dist)
388 DIST_DIR?=${DIST_DIR}
389 else
390 DIST_DIR?=\$(DESTDIR)${prefix}
391 endif
392 LIBSUBDIR=${libdir##${prefix}/}
394 VERSION_MAJOR=${VERSION_MAJOR}
395 VERSION_MINOR=${VERSION_MINOR}
396 VERSION_PATCH=${VERSION_PATCH}
398 CONFIGURE_ARGS=${CONFIGURE_ARGS}
400 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
403 # Write makefiles for all enabled targets
405 for tgt in libs examples docs solution; do
406 local tgt_fn="$tgt-$toolchain.mk"
408 if enabled $tgt; then
409 echo "Creating makefiles for ${toolchain} ${tgt}"
410 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
411 #write_${tgt}_config
413 done
417 process_detect() {
418 if enabled shared; then
419 # Can only build shared libs on a subset of platforms. Doing this check
420 # here rather than at option parse time because the target auto-detect
421 # magic happens after the command line has been parsed.
422 enabled linux || die "--enable-shared only supported on ELF for now"
424 if [ -z "$CC" ]; then
425 echo "Bypassing toolchain for environment detection."
426 enable external_build
427 check_header() {
428 log fake_check_header "$@"
429 header=$1
430 shift
431 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
432 disable $var
433 case $header in
434 stdio.h)
435 true;
438 local result=false
439 for d in "$@"; do
440 [ -f "${d##-I}/$header" ] && result=true && break
441 done
442 ${result:-true}
443 esac && enable $var
445 check_ld() {
446 true
449 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
450 check_ld <<EOF || die "Toolchain is unable to link executables"
451 int main(void) {return 0;}
453 # check system headers
454 check_header stdint.h
455 check_header pthread.h
456 check_header sys/mman.h
458 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
461 process_toolchain() {
462 process_common_toolchain
464 # Handle universal binaries for this architecture
465 case $toolchain in
466 universal-darwin*)
467 local darwin_ver=${tgt_os##darwin}
468 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
470 # Intel
471 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
472 if [ $darwin_ver -gt 8 ]; then
473 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
476 esac
479 # Enable some useful compiler flags
480 if enabled gcc; then
481 enabled werror && check_add_cflags -Werror
482 check_add_cflags -Wall
483 check_add_cflags -Wdeclaration-after-statement
484 check_add_cflags -Wdisabled-optimization
485 check_add_cflags -Wpointer-arith
486 check_add_cflags -Wtype-limits
487 check_add_cflags -Wcast-qual
488 enabled extra_warnings || check_add_cflags -Wno-unused
491 if enabled icc; then
492 enabled werror && check_add_cflags -Werror
493 check_add_cflags -Wall
494 check_add_cflags -Wpointer-arith
496 # ICC has a number of floating point optimizations that we disable
497 # in favor of deterministic output WRT to other compilers
498 add_cflags -fp-model precise
501 # Enable extra, harmless warnings. These might provide additional insight
502 # to what the compiler is doing and why, but in general, but they shouldn't
503 # be treated as fatal, even if we're treating warnings as errors.
504 GCC_EXTRA_WARNINGS="
505 -Wdisabled-optimization
506 -Winline
508 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
509 RVCT_EXTRA_WARNINGS="
510 --remarks
512 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
513 if enabled extra_warnings; then
514 for w in ${EXTRA_WARNINGS}; do
515 check_add_cflags ${w}
516 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
517 done
520 # ccache only really works on gcc toolchains
521 enabled gcc || soft_disable ccache
522 if enabled mips; then
523 enable dequant_tokens
524 enable dc_recon
527 # Enable the postbuild target if building for visual studio.
528 case "$tgt_cc" in
529 vs*) enable msvs
530 enable solution
531 vs_version=${tgt_cc##vs}
532 all_targets="${all_targets} solution"
534 esac
536 # Other toolchain specific defaults
537 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
542 ## END APPLICATION SPECIFIC CONFIGURATION
544 CONFIGURE_ARGS="$@"
545 process "$@"
546 cat <<EOF > ${BUILD_PFX}vpx_config.c
547 static const char* const cfg = "$CONFIGURE_ARGS";
548 const char *vpx_codec_build_config(void) {return cfg;}